{% extends 'index.html' %}
{% load static %}


{% block header-js %}
  <script src="{% static 'assets/js/vue/vee-validate.min.js' %}"></script>
{% endblock %}

{% block title %}{{ html_title }}{% endblock title %}
{% block page %}
  <div id="user-edit" class="user-edit" v-cloak>
    <div class="section section_default">
      <div class="section__content">
        <div class="section__header">
          <h1 class="section__title">{{ html_title }}</h1>
        </div>
        <div class="section__body">
          <form id="form" class="form form_default" method="post" enctype="multipart/form-data">
            {% csrf_token %}
            <div class="form__item form-group form-group_default readonly-switch">
              <div class="form-group__header">
                <h3>Аккаунт</h3>
              </div>
              <div class="form-group__body">
                <div class="fieldset fieldset_grid3">
                  {% if form.filials %}
                    <div class="fieldset__item field">
                      <label for="{{ form.filials.id_for_label }}" class="label label_default label_s">филиал</label>
                      <div class="control control_default control_m">
                        {% if not user.is_client %}
                          {{ form.filials }}
                          <div v-show="errors.has('{{ form.filials.name }}')" class="msg msg_field msg_fail">Поле обязательное для заполнения</div>
                        {% else %}
                          <span class="select2 select2-container select2-container--default select2-container--focus" dir="ltr" style="width: 304px;">
                              <span class="selection">
                                <span class="select2-selection select2-selection--multiple" role="combobox" aria-haspopup="true" aria-expanded="false" tabindex="-1">
                                <ul class="select2-selection__rendered">
                                  {% for value, text in form.filials.field.choices %}
                                      {% if value in form.filials.value %}
                                        <li class="select2-search select2-search--inline">{{text}}</li>
                                      {% endif %}
                                  {% endfor %}
                                </ul>
                                </span>
                            </span>
                          </span>
                        {% endif %}
                      </div>
                    </div>
                  {% endif %}
                  {% if form.groups %}
                    <div class="fieldset__item field">
                      <label class="label label_default label_s">роль</label>
                      <div class="control control_default control_m">
                        <select v-select2="group" name="{{ form.groups.name }}">
                          {% for value, text in form.groups.field.choices %}
                            <option value="{{ value }}" {% if value in form.groups.value %} selected {% endif %}>{{ text }}</option>
                          {% endfor %}
                        </select>
                        <div v-show="errors.has('{{ form.groups.name }}')" class="msg msg_field msg_fail">Поле обязательное для заполнения</div>
                      </div>
                    </div>
                  {% endif %}
                  {% if form.expert_level %}
                    <div v-if="group == expertGroupId" class="fieldset__item field">
                      <label class="label label_default label_s">класс эксперта</label>
                      <div class="control control_default control_m">
                        <select name="{{ form.expert_level.name }}" value="{{ form.expert_level.value }}">
                          {% for level in expert_levels %}
                            <option {% if form.expert_level.value == level %} selected {% endif %}>{{ level }}</option>
                          {% endfor %}
                        </select>
                      </div>
                    </div>
                  {% endif %}
                {% if user.is_leader %}
                    <div v-if="group == expertGroupId" class="email_send_expert">
                        <label class="label label_default label_s">Отправлять уведомления на почту</label>
                        {{ form.is_send_email }}
                    </div>
                {% endif %}
                </div>
              </div>
            </div>
            <div class="form__item form-group form-group_default readonly-switch">
              <div class="form-group__header">
                <h3>Персональные данные</h3>
              </div>
              <div class="form-group__body">
                <div class="fieldset fieldset_grid3">
                  {% if form.last_name %}
                    <div class="fieldset__item field">
                      <label class="label label_default label_s">фамилия</label>
                      <div class="control control_default control_m">
                        <input name="{{ form.last_name.name }}" value="{{ form.last_name.value|default:'' }}" type="text">
                      </div>
                      <div v-show="errors.has('{{ form.last_name.name }}')" class="msg msg_field msg_fail">Поле обязательное для заполнения</div>
                    </div>
                  {% endif %}
                  {% if form.first_name %}
                    <div class="fieldset__item field">
                      <label class="label label_default label_s">имя</label>
                      <div class="control control_default control_m">
                        <input name="{{ form.first_name.name }}" value="{{ form.first_name.value|default:'' }}" type="text">
                      </div>
                      <div v-show="errors.has('{{ form.first_name.name }}')" class="msg msg_field msg_fail">Поле обязательное для заполнения</div>
                    </div>
                  {% endif %}
                  {% if form.patronymic %}
                    <div class="fieldset__item field">
                      <label class="label label_default label_s">отчество</label>
                      <div class="control control_default control_m">
                        <input name="{{ form.patronymic.name }}" value="{{ form.patronymic.value|default:'' }}" type="text">
                      </div>
                      <div v-show="errors.has('{{ form.patronymic.name }}')" class="msg msg_field msg_fail">Поле обязательное для заполнения</div>
                    </div>
                  {% endif %}
                  {% if form.email %}
                    <div class="fieldset__item field">
                      <label class="label label_default label_s">email</label>
                      <div class="control control_default control_m">
                        <input v-validate="'required|email'" class="validateVin" name="{{ form.email.name }}" value="{{ form.email.value|default:'' }}" type="text">
                      </div>
                      <div v-show="errors.has('{{ form.email.name }}')" class="msg msg_field msg_fail">Поле обязательное для заполнения</div>
                    </div>
                  {% endif %}
                  {% if form.phone %}
                    <div class="fieldset__item field">
                      <label class="label label_default label_s">телефон</label>
                      <div class="control control_default control_m">
                        <input v-validate="'required'" id="id_phone" class="validateVin" name="{{ form.phone.name }}" value="{{ form.phone.value|default:'' }}" type="text">
                      </div>
                      <div v-show="errors.has('{{ form.phone.name }}')" class="msg msg_field msg_fail">Поле обязательное для заполнения</div>
                    </div>
                  {% endif %}
                  {% if user_id %}
                    <div class="fieldset__item field">
                      <label class="label label_default label_s">id</label>
                      <div class="control control_default control_m">
                        <input readonly value="{{user_id|default:'' }}" type="text">
                      </div>
                      <div v-show="errors.has('{{ user_id }}')" class="msg msg_field msg_fail">Поле обязательное для заполнения</div>
                    </div>
                  {% endif %}
                </div>
              </div>
            </div>
            {% if request.user.is_admin or request.user.is_acounter or request.user.is_leader %}
                {% if user.user_equipment.all %}
                    {% for equipment in user.user_equipment.all %}
                        <div v-if="group == expertGroupId" id="expertEquipment" class="form__item form-group form-group_default">
                          <div class="form-group__header">
                            <h3>Список оборудования</h3>
                          </div>
                          <div class="form-group__body">
                            <div class="fieldset fieldset_grid3">
                              <div class="fieldset__item field">
                                <label class="label label_default label_s">Толщиномер</label>
                                <div class="control control_default control_m">
                                  <input name="thickness_gauge" value="{{ equipment.thickness_gauge|default:'' }}" type="text">
                                </div>
                              </div>
                              <div class="fieldset__item field">
                                <label class="label label_default label_s">Лаунч</label>
                                <div class="control control_default control_m">
                                  <input name="launch" value="{{ equipment.launch|default:'' }}" type="text">
                                </div>
                              </div>
                              <div class="fieldset__item field">
                                <label class="label label_default label_s">Пароль от лаунч</label>
                                <div class="control control_default control_m">
                                  <input name="launch_password" value="{{ equipment.launch_password|default:'' }}" type="text">
                                </div>
                              </div>
                              <div class="fieldset__item field">
                                <label class="label label_default label_s">Компьютерная диагностика</label>
                                <div class="control control_default control_m">
                                  <input name="comp_diagnostic" value="{{ equipment.comp_diagnostic|default:'' }}" type="text">
                                </div>
                              </div>
                               <div class="fieldset__item field">
                                <label class="check check_m check_default">
                                  <input type="checkbox" class="user-checkbox" value="{{ equipment.gas_analyze|default:'' }}" name="gas_analyze">
                                  <div class="check__icon"></div>
                                  <div class="check__content">
                                    <div class="check__title">Газоанализатор</div>
                                  </div>
                                </label>
                              </div>
                               <div class="fieldset__item field">
                                <label class="check check_m check_default">
                                  <input type="checkbox" class="user-checkbox" value="{{ equipment.endoscope|default:'' }}" name="endoscope">
                                  <div class="check__icon"></div>
                                  <div class="check__content">
                                    <div class="check__title">Эндоскоп</div>
                                  </div>
                                </label>
                              </div>
                               <div class="fieldset__item field">
                                <label class="check check_m check_default">
                                  <input type="checkbox" class="user-checkbox" value="{{ equipment.straightedge|default:'' }}" name="straightedge">
                                  <div class="check__icon"></div>
                                  <div class="check__content">
                                    <div class="check__title">Линейка</div>
                                  </div>
                                </label>
                              </div>
                               <div class="fieldset__item field">
                                <label class="check check_m check_default">
                                  <input type="checkbox" class="user-checkbox" value="{{ equipment.flashlight|default:'' }}" name="flashlight">
                                  <div class="check__icon"></div>
                                  <div class="check__content">
                                    <div class="check__title">Фонарик</div>
                                  </div>
                                </label>
                              </div>
                               <div class="fieldset__item field">
                                <label class="check check_m check_default">
                                  <input type="checkbox" class="user-checkbox" value="{{ equipment.flashlight_ultra_violet|default:'' }}" name="flashlight_ultra_violet">
                                  <div class="check__icon"></div>
                                  <div class="check__content">
                                    <div class="check__title">Фонарик ультра-фиолетовый</div>
                                  </div>
                                </label>
                              </div>
                               <div class="fieldset__item field">
                                <label class="check check_m check_default">
                                  <input type="checkbox" class="user-checkbox" value="{{ equipment.mirror|default:'' }}" name="mirror">
                                  <div class="check__icon"></div>
                                  <div class="check__content">
                                    <div class="check__title">Зеркало</div>
                                  </div>
                                </label>
                              </div>
                               <div class="fieldset__item field">
                                <label class="check check_m check_default">
                                  <input type="checkbox" class="user-checkbox" value="{{ equipment.currency_detector|default:'' }}" name="currency_detector">
                                  <div class="check__icon"></div>
                                  <div class="check__content">
                                    <div class="check__title">Детектор валют</div>
                                  </div>
                                </label>
                              </div>
                              <div class="fieldset__item field">
                                <label class="check check_m check_default">
                                  <input type="checkbox" class="user-checkbox" value="{{ equipment.glu_protector_tire|default:'' }}" name="glu_protector_tire">
                                  <div class="check__icon"></div>
                                  <div class="check__content">
                                    <div class="check__title">Глубиномер протектора шин</div>
                                  </div>
                                </label>
                              </div>
                              <div class="fieldset__item field">
                                <label class="check check_m check_default">
                                  <input type="checkbox" class="user-checkbox" value="{{ equipment.compression_tester|default:'' }}" name="compression_tester">
                                  <div class="check__icon"></div>
                                  <div class="check__content">
                                    <div class="check__title">Компрессометр</div>
                                  </div>
                                </label>
                              </div>
                            </div>
                          </div>
                        </div>
                    {% endfor %}
                {% else %}
                    {% if user_id %}
                    <div v-if="group == expertGroupId" id="expertEquipment" class="form__item form-group form-group_default">
                      <div class="form-group__header">
                        <h3>Список оборудования</h3>
                      </div>
                      <div class="form-group__body">
                        <div class="fieldset fieldset_grid3">
                          <div class="fieldset__item field">
                            <label class="label label_default label_s">Толщиномер</label>
                            <div class="control control_default control_m">
                              <input name="thickness_gauge" value="" type="text">
                            </div>
                          </div>
                          <div class="fieldset__item field">
                            <label class="label label_default label_s">Лаунч</label>
                            <div class="control control_default control_m">
                              <input name="launch" value="" type="text">
                            </div>
                          </div>
                          <div class="fieldset__item field">
                            <label class="label label_default label_s">Пароль от лаунч</label>
                            <div class="control control_default control_m">
                              <input name="launch_password" value="" type="text">
                            </div>
                          </div>
                          <div class="fieldset__item field">
                            <label class="label label_default label_s">Компьютерная диагностика</label>
                            <div class="control control_default control_m">
                              <input name="comp_diagnostic" value="" type="text">
                            </div>
                          </div>
                           <div class="fieldset__item field">
                            <label class="check check_m check_default">
                              <input type="checkbox" class="user-checkbox" value="" name="gas_analyze">
                              <div class="check__icon"></div>
                              <div class="check__content">
                                <div class="check__title">Газоанализатор</div>
                              </div>
                            </label>
                          </div>
                           <div class="fieldset__item field">
                            <label class="check check_m check_default">
                              <input type="checkbox" class="user-checkbox" value="" name="endoscope">
                              <div class="check__icon"></div>
                              <div class="check__content">
                                <div class="check__title">Эндоскоп</div>
                              </div>
                            </label>
                          </div>
                           <div class="fieldset__item field">
                            <label class="check check_m check_default">
                              <input type="checkbox" class="user-checkbox" value="" name="straightedge">
                              <div class="check__icon"></div>
                              <div class="check__content">
                                <div class="check__title">Линейка</div>
                              </div>
                            </label>
                          </div>
                           <div class="fieldset__item field">
                            <label class="check check_m check_default">
                              <input type="checkbox" class="user-checkbox" value="" name="flashlight">
                              <div class="check__icon"></div>
                              <div class="check__content">
                                <div class="check__title">Фонарик</div>
                              </div>
                            </label>
                          </div>
                           <div class="fieldset__item field">
                            <label class="check check_m check_default">
                              <input type="checkbox" class="user-checkbox" value="" name="flashlight_ultra_violet">
                              <div class="check__icon"></div>
                              <div class="check__content">
                                <div class="check__title">Фонарик ультра-фиолетовый</div>
                              </div>
                            </label>
                          </div>
                           <div class="fieldset__item field">
                            <label class="check check_m check_default">
                              <input type="checkbox" class="user-checkbox" value="" name="mirror">
                              <div class="check__icon"></div>
                              <div class="check__content">
                                <div class="check__title">Зеркало</div>
                              </div>
                            </label>
                          </div>
                           <div class="fieldset__item field">
                            <label class="check check_m check_default">
                              <input type="checkbox" class="user-checkbox" value="" name="currency_detector">
                              <div class="check__icon"></div>
                              <div class="check__content">
                                <div class="check__title">Детектор валют</div>
                              </div>
                            </label>
                          </div>
                          <div class="fieldset__item field">
                            <label class="check check_m check_default">
                              <input type="checkbox" class="user-checkbox" value="" name="glu_protector_tire">
                              <div class="check__icon"></div>
                              <div class="check__content">
                                <div class="check__title">Глубиномер протектора шин</div>
                              </div>
                            </label>
                          </div>
                          <div class="fieldset__item field">
                            <label class="check check_m check_default">
                              <input type="checkbox" class="user-checkbox" value="" name="compression_tester">
                              <div class="check__icon"></div>
                              <div class="check__content">
                                <div class="check__title">Компрессометр</div>
                              </div>
                            </label>
                          </div>
                        </div>
                      </div>
                    </div>
                    {% else %}
                    {% endif %}
                {% endif %}
            {% endif %}
            {% if form.avatar %}
              <div class="form__item form-group form-group_default">
                <div class="form-group__header">
                  <h3>Фотография</h3>
                </div>
                <div class="form-group__body">
                  <div class="user-thumb-edit">
                    <img id="ava" class="user-thumb-edit__thumb" {% if form.avatar.value %} src="{{ form.avatar.value.url }}" {% endif %}/>
                    <div class="user-thumb-edit__controls">
                      <div id="upload-avatar-button" class="btn btn_s btn_primary">
                        <div class="btn__title"> Загрузить</div>

                        <input id="{{ form.avatar.name }}" name="{{ form.avatar.name }}" type="file" accept="image/*" value="{{ form.avatar.value }}" style="display:none;">
                      </div>
                      <div id="remove-avatar-button" class="btn btn_s btn_default mt_xs">
                        <div class="btn__title">Удалить</div>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            {% endif %}
            {% if field_perms.user.password and not create %}
              <div class="form__item form-group form-group_default">
                <div class="form-group__header">
                  <h3>Сменить пароль</h3>
                </div>
                <div class="form-group__body">
                  <div class="fieldset fieldset_grid3">
                    <div class="fieldset__item field">
                      <label class="label label_default label_s">текущий пароль</label>
                      <div class="control control_default control_m">
                        <input name="{{ password_change_form.old_password.name }}" type="password">
                      </div>
                      <div v-show="errors.has('{{ password_change_form.old_password.name }}')" class="msg msg_field msg_fail">Поле обязательное для заполнения</div>
                    </div>
                    <div class="fieldset__item field">
                      <label class="label label_default label_s">новый пароль</label>
                      <div class="control control_default control_m">
                        <input name="{{ password_change_form.new_password1.name }}" type="password">
                      </div>
                      <div v-show="errors.has('{{ password_change_form.new_password1.name }}')" class="msg msg_field msg_fail">Поле обязательное для заполнения</div>
                    </div>
                    <div class="fieldset__item field">
                      <label class="label label_default label_s">новый пароль еще раз</label>
                      <div class="control control_default control_m">
                        <input name="{{ password_change_form.new_password2.name }}" type="password">
                      </div>
                      <div v-show="errors.has('{{ password_change_form.new_password2.name }}')" class="msg msg_field msg_fail">Поле обязательное для заполнения</div>
                    </div>
                  </div>
                </div>
              </div>
            {% elif create %}
              <div class="form__item form-group form-group_default">
                <div class="form-group__header">
                  <h3>Пароль</h3>
                </div>
                <div class="form-group__body">
                  <div class="fieldset fieldset_grid3">
                    <div class="fieldset__item field">
                      <label class="label label_default label_s">пароль</label>
                      <div class="control control_default control_m">
                        <input v-validate="'required'" v-model='password' class="validateVin" v-if="password  == null" type="password" name="{{ form.password1.name }}">
                        <input  v-validate="'required'" v-model='password' class="validateVin" v-else type="text" name="{{ form.password1.name }}">
                      </div>
                      <div v-show="errors.has('{{ form.password1.name }}')" class="msg msg_field msg_fail">Поле обязательное для заполнения</div>
                    </div>
                    <div class="fieldset__item field">
                      <label class="label label_default label_s">подтверждение пароля</label>
                      <div class="control control_default control_m">
                        <input v-validate="'required'" name="{{ form.password2.name }}" class="validateVin" v-model='password_confirm' v-if="password == null" type="password" >
                        <input v-validate="'required'" name="{{ form.password2.name }}" class="validateVin" v-model='password' v-else type="text">
                      </div>
                      <div v-show="errors.has('{{ form.password2.name }}')" class="msg msg_field msg_fail">Поле обязательное для заполнения</div>
                    </div>
                    <div style="margin-top: 20px;" class="fieldset__item field">
                      <button @click.prevent="generatePass" class="btn btn_m btn_primary btn_block">
                        <div class="btn__grid">
                          <div class="btn__title">сгенерировать пароль</div>
                        </div>
                      </button>
                    </div>
                  </div>
                </div>
              </div>
            {% endif %}
            <div class="form__item">
              <button @click.prevent="validateBeforeSubmit" class="btn btn_m btn_primary btn_block">
                <div class="btn__grid">
                  <div class="btn__title">Сохранить</div>
                </div>
              </button>
            </div>
          </form>
        </div>
      </div>
    </div>
  </div>
{% endblock %}

{% block script %}
  {{ block.super }}
  <script>
    var user_id = {{ user.id }}
    var expertGroupId = 0;
    {% for value, text in form.groups.field.choices %}
      {% if text == 'Эксперт' %}
        expertGroupId = {{ value }};
      {% endif %}
    {% endfor %}
  </script>
  <script src="{% static 'js/useredit.bundle.js' %}"></script>
  <script>
    $(document).ready(function () {
        $('select').select2({});


        $('#remove-avatar-button').on('click', function(e) {
          let container = new DataTransfer();
          $('#ava').attr('src', '');
          $("#avatar").get(0).files = container.files;
        });

        $('#upload-avatar-button').on('click', function() {
          document.getElementById('{{ form.avatar.name }}').click();
        });
    });
    $(window).on('load',function(){
      let src = $("#ava").attr('src');
      const fileName = (Math.random() + 1).toString(36).substring(2) + '.jpg';

      if(src !== undefined){
        imgSet(src);
      }else{
        $(document).on('change', '#avatar', function(){
          $("#ava").attr('src', URL.createObjectURL(this.files[0]));
        })
      }

      function imgSet(src){
        fetch(src)
        .then(async response => {
          const contentType = response.headers.get('content-type')
          const blob = await response.blob()
          const file = new File([blob], fileName, { contentType })
          let container = new DataTransfer();

          container.items.add(file);
          $("#avatar").get(0).files = container.files;
        }).then(async response => {
          let loadFile = $('#avatar').get(0).files[0];
          $("#ava").attr('src', URL.createObjectURL(loadFile));
          
          $(document).on('change', '#avatar', function(){
            if(this.files.length === 0){
              src = $("#ava").attr('src');
              $("#ava").attr('src', URL.createObjectURL(loadFile));
              imgSet(src);
            }else{
              $("#ava").attr('src', URL.createObjectURL(this.files[0]));
            }
          })
        })
      }
    })
  </script>
{% endblock %}
